with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_ProxyPullSupplier_Hash is

   P : constant array (0 .. 4) of Natural :=
     (1, 2, 4, 9, 10);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (9, 36, 25, 19, 39);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (11, 27, 38, 31, 7);

   G : constant array (0 .. 52) of Unsigned_8 :=
     (0, 0, 0, 0, 14, 13, 0, 0, 9, 0, 0, 3, 0, 0, 0, 1, 17, 21, 0, 0, 22, 0,
      0, 17, 0, 0, 3, 16, 4, 0, 0, 0, 0, 0, 4, 0, 11, 0, 0, 15, 9, 0, 3, 0,
      21, 20, 2, 0, 16, 1, 19, 0, 22);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 53;
         F2 := (F2 + Natural (T2 (K)) * J) mod 53;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 26;
   end Hash;

end CosNotifyChannelAdmin_ProxyPullSupplier_Hash;
